#ifndef __GEO_MESH__
#define __GEO_MESH__

#include <vector>
#include <ostream>

#include "GeoBase.h"
#include "GeoVertexBuffer.h"
#include "GeoSerializable.h"
#include "GeoSubMesh.h"

namespace Geometry {
	
	/// Mesh class interface
	class Mesh : public Serializable
	{
	public:
		/// Constructor
		Mesh();

		/// Destructor
		~Mesh();

		/// Copy constructor
		//Mesh(const Mesh&);

		/// Assignment operator
		//Mesh& operator =(const Mesh&);

		/// Loads data from a Serializer
		void Load(Serializer &s);

		/// Saves data to a Serializer
		void Save(Serializer &s);

		VertexBuffer  *mVertexBuffer; ///< Shared VertexBuffer
		SubMesh *mSubMesh;        ///< Array of subMesehs
		size_t   mSubMeshCount;   ///< Total count of subMeshes
		MeshType mType;           ///< Type of mesh
	};

} //end of Geometry namespace

#endif
